local MEKA = unpack(select(2, ...))  -->Engine
local E, C, F, L = unpack(Quafe)  -->Engine, Config, Function, Locale

--- ------------------------------------------------------------
--> API Localization
--- ------------------------------------------------------------

local _G = getfenv(0)
local format = string.format
local find = string.find

local min = math.min
local max = math.max
local floor = math.floor
local sqrt = math.sqrt
local sin = math.sin
local cos = math.cos
local rad = math.rad
local acos = math.acos
local atan = math.atan
local rad = math.rad
local modf = math.modf

local insert = table.insert
local remove = table.remove
local wipe = table.wipe

local BurstHaste = {
	"146555", --暴怒之鼓
	"178207", --狂怒战鼓
	"230935", --高山战鼓
	"2825", --嗜血
	"32182", --英勇
	"80353", --时间扭曲
	"90355", --远古狂乱
	"160452", --虚空之风
}

--- ------------------------------------------------------------
--> Class Points
--- ------------------------------------------------------------

local NUM_COORD = {
	[0] =   {  0/256, 15/256, 4/32,27/32},
	[1] =   { 15/256, 30/256, 4/32,27/32},
	[2] =   { 30/256, 45/256, 4/32,27/32},
	[3] =   { 45/256, 60/256, 4/32,27/32},
	[4] =   { 60/256, 75/256, 4/32,27/32},
	[5] =   { 75/256, 90/256, 4/32,27/32},
	[6] =   { 90/256,105/256, 4/32,27/32},
	[7] =   {105/256,120/256, 4/32,27/32},
	[8] =   {120/256,135/256, 4/32,27/32},
	[9] =   {135/256,150/256, 4/32,27/32},
	["X"] = {150/256,165/256, 4/32,27/32},
	["B"] = {255/256,256/256, 4/32,27/32},
}

local function update_Ring(f, d)
	if f.RR then
		if not d then d = 1 end
		d = min(max(d, 0), 1)
		f.RR.Bar:SetRotation(math.rad(f.RR.Base+180*d))
	end
end

local function Ring_Artwork(f, size, texture)
	local SC = CreateFrame("Frame", nil, f)
	SC: SetSize(size, size)
	SC: SetPoint("CENTER")
	f: SetScrollChild(SC)
	
	local Ring = SC:CreateTexture(nil, "ARTWORK")
	Ring: SetTexture(F.Path(texture))
	Ring: SetSize(size, size)
    Ring: SetPoint("CENTER")
    Ring: SetVertexColor(F.Color(C.Color.Main1))
	Ring: SetAlpha(1)
	--Ring: SetBlendMode("BLEND")
	Ring: SetRotation(math.rad(f.Base+180))
	f.Bar = Ring
end

local function Create_Ring(f, size, texture)
	f.RingTimer = 0
	f.RingDuration = 0

	f.RR = CreateFrame("ScrollFrame", nil, f)
	--f.RR: SetFrameLevel(level)
	f.RR: SetSize((size)/2, size)
	f.RR: SetPoint("LEFT", f, "CENTER", 0,0)
	f.RR: SetHorizontalScroll((size)/2)
	f.RR.Base = -180
	Ring_Artwork(f.RR, size, texture)
end

local function Points_Artwork(f)
	local Ring1 = CreateFrame("Frame", nil, f)
	Ring1: SetSize(54,54)
	Ring1: SetPoint("CENTER", f, "CENTER", 0,0)
	Create_Ring(Ring1, 64, "Points\\Bar")

	local Ring1_Bg = f: CreateTexture(nil, "BACKGROUND")
	Ring1_Bg: SetTexture(F.Path("Points\\BarBg"))
	Ring1_Bg: SetVertexColor(F.Color(C.Color.W1))
	Ring1_Bg: SetAlpha(0.9)
	Ring1_Bg: SetSize(64,64)
	Ring1_Bg: SetPoint("CENTER", f, "CENTER", 0,0)

	local Ring1_Bg_Glow = f: CreateTexture(nil, "BORDER")
	Ring1_Bg_Glow: SetTexture(F.Path("Points\\BarBg"))
	Ring1_Bg_Glow: SetVertexColor(F.Color(C.Color.Main1))
	Ring1_Bg_Glow: SetAlpha(0.2)
	Ring1_Bg_Glow: SetSize(64,64)
	Ring1_Bg_Glow: SetPoint("CENTER", f, "CENTER", 0,0)

	f.Num = {}
	f.NumHold = CreateFrame("Frame", nil, f)
	f.NumHold: SetSize(12,12)
	f.NumHold: SetPoint("CENTER", f, "CENTER", 0,0)
	for i = 1,2 do
		f.Num[i] = f.NumHold: CreateTexture(nil, "OVERLAY")
		f.Num[i]: SetTexture(F.Path("Points\\Num26"))
		f.Num[i]: SetVertexColor(F.Color(C.Color.Main1))
		f.Num[i]: SetAlpha(1)
		f.Num[i]: SetSize(15,23)
		f.Num[i]: SetTexCoord(NUM_COORD[0][1],NUM_COORD[0][2], NUM_COORD[0][3],NUM_COORD[0][4])
		f.Num[i]: SetPoint("CENTER", f.NumHold, "CENTER", -10*(i-1),0)
	end
	f.Num.Unit = f.NumHold: CreateTexture(nil, "OVERLAY")
	f.Num.Unit: SetTexture(F.Path("Points\\Num26"))
	f.Num.Unit: SetVertexColor(F.Color(C.Color.Main1))
	f.Num.Unit: SetAlpha(0.9)
	f.Num.Unit: SetSize(15,23)
	f.Num.Unit: SetTexCoord(NUM_COORD["X"][1],NUM_COORD["X"][2], NUM_COORD["X"][3],NUM_COORD["X"][4])
	f.Num.Unit: SetPoint("CENTER", f.NumHold, "CENTER", 9,0)

	f.Ring = Ring1
	f.Ring.Bg = Ring1_Bg
end

local function Point_Event(frame)
	local d, d1, d2
	if frame.Info.CP > 0 then
		d = frame.Info.CP
		d2 = floor(d/10)
		d1 = max(floor(d - d2*10), 0)
		if d2 < 1 then
			d2 = "B"
		end
		frame.Num[1]: SetTexCoord(NUM_COORD[d1][1],NUM_COORD[d1][2], NUM_COORD[d1][3],NUM_COORD[d1][4])
		frame.Num[2]: SetTexCoord(NUM_COORD[d2][1],NUM_COORD[d2][2], NUM_COORD[d2][3],NUM_COORD[d2][4])
	elseif frame.Info.E then
		d = frame.Info.E
		d2 = floor(d/10)
		d1 = max(floor(d - d2*10), 0)
		if d2 < 1 then
			d2 = "B"
		end
		frame.Num[1]: SetTexCoord(NUM_COORD[d1][1],NUM_COORD[d1][2], NUM_COORD[d1][3],NUM_COORD[d1][4])
		frame.Num[2]: SetTexCoord(NUM_COORD[d2][1],NUM_COORD[d2][2], NUM_COORD[d2][3],NUM_COORD[d2][4])
	end

	if frame.Info.CP > 0 then
		frame: SetAlpha(1)
	else
		frame: SetAlpha(frame.Info.Alpha)
	end
end
--[[
local function Point_CTA(frame)
	if frame.Info.E and frame.Info.MP > 0 then
		local d, d1, d2
		d = frame.Info.E
		d2 = floor(d/10)
		d1 = max(floor(d - d2*10), 0)
		if d2 < 1 then
			d2 = "B"
		end
		frame.Num[1]: SetTexCoord(NUM_COORD[d1][1],NUM_COORD[d1][2], NUM_COORD[d1][3],NUM_COORD[d1][4])
		frame.Num[2]: SetTexCoord(NUM_COORD[d2][1],NUM_COORD[d2][2], NUM_COORD[d2][3],NUM_COORD[d2][4])
	end
	C_Timer.After(0.1, function(self) Point_CTA(frame) end)
end

local function Monk_Mistweaver_CTA(frame)
	if frame.Info.MistweaverUpdate then
		if (frame.Info.SpecID == SPEC_MONK_MISTWEAVER) then
			local count = GetSpellCount("205406")
			frame.Info.E = count
			frame.Info.MP = 12
			update_Ring(frame.Ring, 1, true)
			if frame.Info.E ~= 0 then
				frame: SetAlpha(1)
				if not frame:IsShown() then
					frame.SlideIn: Play()
				end
			else
				if frame:IsShown() then
					frame.SlideOut: Play()
				end
			end
		end
		C_Timer.After(0.1, function(self) Monk_Mistweaver_CTA(frame) end)
	end
end
]]--
--> ComboPoint
local function ComboPoint_Event(frame, event, ...)
	frame.Info.CP = UnitPower("player", 4)
	frame.Info.CMP = UnitPowerMax("player", 4)
end

--> DeathKnight
local function DeathKnight_Event(frame, event, ...)
	if (frame.Info.Class == "DEATHKNIGHT") then
		if event == "PLAYER_ENTERING_WORLD" or event == "PLAYER_SPECIALIZATION_CHANGED" then
			if (frame.Info.SpecID == 1) then
				if (not E.AuraUpdate.AuraList["195181"]) then
					E.AuraUpdate.AuraList["195181"] = {
						Aura = "195181",
						Unit = "player",
						Caster = "player",
					}
				end
			end
			if (frame.Info.SpecID == 3) then
				if (not E.AuraUpdate.AuraList["194310"]) then
					E.AuraUpdate.AuraList["194310"] = {
						Aura = "194310",
						Unit = "target",
						Caster = "player",
					}
				end
			end
		end
		if (frame.Info.SpecID == 1) then
			frame.Info.MP = 10
		end
		if (frame.Info.SpecID == 3) then
			frame.Info.MP = 8
		end
	end
end

local function DeathKnight_Update(frame, elapsed)
	if (frame.Info.Class == "DEATHKNIGHT") then
		if (frame.Info.SpecID == 1) then
			frame.Info.E = E.AuraUpdate.AuraList["195181"].Count or 0
			frame.Info.Remain = E.AuraUpdate.AuraList["195181"].Remain or 0
			frame.Info.Duration = E.AuraUpdate.AuraList["195181"].Duration
			if E.AuraUpdate.AuraList["195181"].Remain and (E.AuraUpdate.AuraList["195181"].Remain > 0) then
				E.AuraUpdate.AuraList["195181"].Remain = E.AuraUpdate.AuraList["195181"].Remain - elapsed
			end
		end
		if (frame.Info.SpecID == 3) then
			frame.Info.E = E.AuraUpdate.AuraList["194310"].Count or 0
			frame.Info.Remain = E.AuraUpdate.AuraList["194310"].Remain or 0
			frame.Info.Duration = E.AuraUpdate.AuraList["194310"].Duration
			if E.AuraUpdate.AuraList["194310"].Remain and (E.AuraUpdate.AuraList["194310"].Remain > 0) then
				E.AuraUpdate.AuraList["194310"].Remain = E.AuraUpdate.AuraList["194310"].Remain - elapsed
			end
		end
		if (frame.Info.SpecID == 1) or (frame.Info.SpecID == 3) then
			if frame.Info.Remain and (frame.Info.Remain > 0) then
				update_Ring(frame.Ring, frame.Info.Remain/(frame.Info.Duration+F.Debug))
			else
				update_Ring(frame.Ring, 1)
			end
			if frame.Info.E == 0 then
				frame.Info.Alpha = 0
			elseif UnitAffectingCombat("player") then
				frame.Info.Alpha = 1
			else
				frame.Info.Alpha = 0.4
			end
		end
	end
end

--> Druid
local function Druid_Event(frame, event, ...)
	if (frame.Info.Class == "DRUID") then
		if event == "PLAYER_ENTERING_WORLD" then
			frame: RegisterEvent("UPDATE_SHAPESHIFT_FORM")
		end
		if event == "PLAYER_ENTERING_WORLD" or "UPDATE_SHAPESHIFT_FORM" then
			frame.Info.Form = GetShapeshiftFormID()
		end
		--CAT_FORM
	end
end

--> Mage
local function Mage_Event(frame, event, ...)
	if (frame.Info.Class == "MAGE") then
		if (frame.Info.SpecID == SPEC_MAGE_ARCANE) then
			frame.Info.E = UnitPower("player", 16)
			frame.Info.MP = UnitPowerMax("player", 16)
			update_Ring(frame.Ring, 1, true)
			if frame.Info.E == 0 then
				frame.Info.Alpha = 0
			elseif UnitAffectingCombat("player") then
				frame.Info.Alpha = 1
			else
				frame.Info.Alpha = 0.4
			end
		end
	end
end

--> 武僧
local function Monk_Event(frame, event, ...)
	if (frame.Info.Class == "MONK") then
		if event == "PLAYER_ENTERING_WORLD" or event == "PLAYER_SPECIALIZATION_CHANGED" then
			frame.Ring.RR.Bar: SetVertexColor(F.Color(C.Color.W3))
			frame.Ring.Bg: SetVertexColor(F.Color(C.Color.W1))

			if (frame.Info.SpecID == SPEC_MONK_BREWMASTER) then
				frame: UnregisterEvent("UNIT_MAXPOWER")
				frame: RegisterEvent("SPELL_UPDATE_COOLDOWN")
			elseif (frame.Info.SpecID == SPEC_MONK_MISTWEAVER) then
				frame: UnregisterEvent("UNIT_MAXPOWER")
				frame: RegisterEvent("SPELL_UPDATE_COOLDOWN")
			elseif (frame.Info.SpecID == SPEC_MONK_WINDWALKER) then
				frame: RegisterUnitEvent("UNIT_MAXPOWER", "player")
				frame: UnregisterEvent("SPELL_UPDATE_COOLDOWN")
			end
		end
		--> 酒仙
		if (frame.Info.SpecID == SPEC_MONK_BREWMASTER) then
			if event == "PLAYER_ENTERING_WORLD" or event == "PLAYER_SPECIALIZATION_CHANGED" or event == "SPELL_UPDATE_COOLDOWN" then
				local count, maxcount = GetSpellCharges("119582") --活血酒
				frame.Info.E = count
				frame.Info.MP = maxcount
			end
		--> 织雾
		elseif (frame.Info.SpecID == SPEC_MONK_MISTWEAVER) then
			--local count = GetSpellCount("115151") --复苏之雾
			if event == "PLAYER_ENTERING_WORLD" or event == "PLAYER_SPECIALIZATION_CHANGED" or event == "SPELL_UPDATE_COOLDOWN" then
				local count, maxcount, expiration, duration = GetSpellCharges("115151") --复苏之雾
				frame.Info.E = count
				frame.Info.MP = maxcount or 2
				frame.Info.Remain = GetTime() - (expiration or 0)
				frame.Info.Duration = duration
				update_Ring(frame.Ring, frame.Info.Remain/(frame.Info.Duration+F.Debug))
			end
			--update_Ring(frame.Ring, 1, true)
			if frame.Info.E == frame.Info.MP then
				frame.Info.Alpha = 0
			else
				frame.Info.Alpha = 1
			end
			
		--> 踏风
		elseif (frame.Info.SpecID == SPEC_MONK_WINDWALKER) then 
			frame.Info.E = UnitPower("player", 12)
			frame.Info.MP = UnitPowerMax("player", 12)
			update_Ring(frame.Ring, 1, true)
			if frame.Info.E == 0 then
				frame.Info.Alpha = 0
			elseif UnitAffectingCombat("player") then
				frame.Info.Alpha = 1
			else
				frame.Info.Alpha = 0.4
			end
		end
	end
end

local function Monk_Update(frame, elapsed)
	if (frame.Info.Class == "MONK") then
		--> 酒仙
		if (frame.Info.SpecID == SPEC_MONK_BREWMASTER) then
			local currstagger = UnitStagger("player");
			local maxstagger = UnitHealthMax("player");
			local percent = currstagger/maxstagger;

			if UnitAffectingCombat("player") then
				frame.Info.Alpha = 1
			elseif (percent == 0) and (frame.Info.E == frame.Info.MP) then
				frame.Info.Alpha = 0
			else
				frame.Info.Alpha = 0.4
			end

			if (percent > 1) then
				percent = percent - 1
				frame.Ring.RR.Bar: SetVertexColor(F.Color(C.Color.R3))
				frame.Ring.Bg: SetVertexColor(F.Color(C.Color.Y3))
			elseif (percent >= 0.5) then
				frame.Ring.RR.Bar: SetVertexColor(F.Color(C.Color.Y3))
				frame.Ring.Bg: SetVertexColor(F.Color(C.Color.W1))
			else
				frame.Ring.RR.Bar: SetVertexColor(F.Color(C.Color.W3))
				frame.Ring.Bg: SetVertexColor(F.Color(C.Color.W1))
			end
			update_Ring(frame.Ring, percent)
		--> 织雾
		elseif (frame.Info.SpecID == SPEC_MONK_MISTWEAVER) then
			if frame.Info.Remain and (frame.Info.Remain >= 0) and (frame.Info.Remain <= frame.Info.Duration) then
				update_Ring(frame.Ring, frame.Info.Remain/(frame.Info.Duration+F.Debug))
				frame.Info.Remain = frame.Info.Remain + elapsed
			else
				update_Ring(frame.Ring, 1)
			end
		end
	end
end

--> Paladin
local function Paladin_Event(frame, event, ...)
	if (frame.Info.Class == "PALADIN") then
		if (frame.Info.SpecID == SPEC_PALADIN_RETRIBUTION) then
			frame.Info.E = UnitPower("player", 9)
			frame.Info.MP = UnitPowerMax("player", 9)
			update_Ring(frame.Ring, 1, true)
			if frame.Info.E == 0 then
				frame.Info.Alpha = 0
			elseif UnitAffectingCombat("player") then
				frame.Info.Alpha = 1
			else
				frame.Info.Alpha = 0.4
			end
		end
	end
end

--> Warlock
local function Warlock_Event(frame, event, ...)
	if (frame.Info.Class == "WARLOCK") then
		frame.Info.E = UnitPower("player", 7)
		frame.Info.MP = UnitPowerMax("player", 7)
		if (frame.Info.SpecID == SPEC_WARLOCK_DESTRUCTION) then
			local HighPower = UnitPower("player", 7, true)
			local HighPowerMax = UnitPowerMax("player", 7, true)
			local PerShareMax = HighPowerMax/frame.Info.MP
			local PerShare = HighPower - PerShareMax*frame.Info.E
			frame.Info.PP = PerShare/PerShareMax
			update_Ring(frame.Ring, frame.Info.PP, true)
		else
			update_Ring(frame.Ring, 1, true)
		end
		if UnitAffectingCombat("player") then
			frame.Info.Alpha = 1
		else
			if frame.Info.E ~= 3 then
				frame.Info.Alpha = 0.4
			else
				frame.Info.Alpha = 0
			end
		end
	end
end

--> 牧师
local function Priest_Event(frame, event, ...)
	if not (F.PlayerClass == "PRIEST") then return end
	if event == "PLAYER_ENTERING_WORLD" or event == "PLAYER_SPECIALIZATION_CHANGED" then
		if (frame.Info.SpecID == 3) then
			if (not E.AuraUpdate.AuraList["194249"]) then --虚空形态
				E.AuraUpdate.AuraList["194249"] = {
					Aura = "194249",
					Unit = "player",
				}
			end
			if (not E.AuraUpdate.AuraList["197937"]) then --延宕狂乱
				E.AuraUpdate.AuraList["197937"] = {
					Aura = "197937",
					Unit = "player",
				}
			end
		end
	end
end

local function Priest_Update(frame, elapsed)
	if not (F.PlayerClass == "PRIEST") then return end
	if (frame.Info.SpecID == 3) then
		if E.AuraUpdate.AuraList["194249"].Exist then
			frame.Info.E = E.AuraUpdate.AuraList["194249"].Count or 0
			frame.Info.Remain = E.AuraUpdate.AuraList["194249"].Remain or 0
			frame.Info.Duration = E.AuraUpdate.AuraList["194249"].Duration
		elseif E.AuraUpdate.AuraList["197937"].Exist then
			frame.Info.E = E.AuraUpdate.AuraList["197937"].Count or 0
			frame.Info.Remain = E.AuraUpdate.AuraList["197937"].Remain or 0
			frame.Info.Duration = E.AuraUpdate.AuraList["197937"].Duration
		else
			frame.Info.E = 0
			frame.Info.Remain = 0
			frame.Info.Duration = 0
		end
		if E.AuraUpdate.AuraList["194249"].Remain and (E.AuraUpdate.AuraList["194249"].Remain > 0) then
			E.AuraUpdate.AuraList["194249"].Remain = E.AuraUpdate.AuraList["194249"].Remain - elapsed
		end
		if E.AuraUpdate.AuraList["197937"].Remain and (E.AuraUpdate.AuraList["197937"].Remain > 0) then
			E.AuraUpdate.AuraList["197937"].Remain = E.AuraUpdate.AuraList["197937"].Remain - elapsed
		end
	end
	if (frame.Info.SpecID == 3) then
		if frame.Info.Remain and (frame.Info.Remain > 0) then
			update_Ring(frame.Ring, frame.Info.Remain/(frame.Info.Duration+F.Debug))
		else
			update_Ring(frame.Ring, 1)
		end
		if frame.Info.E == 0 then
			frame.Info.Alpha = 0
		elseif UnitAffectingCombat("player") then
			frame.Info.Alpha = 1
		else
			frame.Info.Alpha = 0.4
		end
	end
end

local function Points_OnEvent(frame)
	frame: RegisterEvent("PLAYER_LOGIN")
	frame: RegisterEvent("PLAYER_ENTERING_WORLD")
	frame: RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
	frame: RegisterEvent("PLAYER_TALENT_UPDATE")
	frame: RegisterEvent("UPDATE_VEHICLE_ACTIONBAR")
	frame: RegisterUnitEvent("UNIT_EXITED_VEHICLE", "player")
	frame: RegisterUnitEvent("UNIT_ENTERED_VEHICLE", "player")
	--frame: RegisterEvent("UNIT_COMBO_POINTS")
	frame: RegisterEvent("PLAYER_TARGET_CHANGED")
	frame: RegisterUnitEvent("UNIT_POWER_UPDATE", "player")
	frame: RegisterUnitEvent("UNIT_MAXPOWER", "player")
	frame: RegisterEvent("PLAYER_REGEN_DISABLED")
	frame: RegisterEvent("PLAYER_REGEN_ENABLED")
	frame: SetScript("OnEvent", function(self, event, ...)
		if event == "PLAYER_ENTERING_WORLD" and frame.Info.CTA_Pruse then
			--frame.Info.CTA_Pruse = false
			--Point_CTA(frame)
		end
		if event == "PLAYER_ENTERING_WORLD" or event == "PLAYER_SPECIALIZATION_CHANGED" then
			self.Info.SpecID = GetSpecialization()
			update_Ring(self.Ring, 1)
			self.Info.Alpha = 0
		end
		ComboPoint_Event(self, event, ...)
		DeathKnight_Event(self, event, ...)
		Druid_Event(self, event, ...)
		Mage_Event(self, event, ...)
		Monk_Event(self, event, ...)
		Paladin_Event(self, event, ...)
		Warlock_Event(self, event, ...)
		Priest_Event(self, event, ...)
	end)
end

local function Points_OnUpdate(frame)
	local Elapsed_Help = 0
	frame: SetScript("OnUpdate", function(self, elapsed)
		Elapsed_Help = Elapsed_Help + elapsed
		if F.Last25H == 0 then
			DeathKnight_Update(self, Elapsed_Help)
			Priest_Update(self, Elapsed_Help)
			Point_Event(self)
			Monk_Update(self, Elapsed_Help)
			Elapsed_Help = 0
		end
	end)
end

local function Points_Frame(frame)
	local Points = CreateFrame("Frame", nil, frame)
	Points: SetSize(12, 12)
	Points: SetPoint("CENTER", f, "CENTER", -200,0)
	Points: SetAlpha(0)
	Points.Info = {}
	--Points.Info.CTA_Pruse = true
	Points.Info.E = 0
	Points.Info.MP = 0
	Points.Info.CP = 0
	Points.Info.CMP = 0
	Points.Info.Value = 0
	Points.Info.Class = select(2, UnitClass("player"))
	Points.Info.Alpha = 0

	Points.Info.Remain = 0
	Points.Info.Duration = 1
	
	Points_Artwork(Points)
	Points_OnEvent(Points)
	Points_OnUpdate(Points)
end

--- ------------------------------------------------------------
--> Rune Power
--- ------------------------------------------------------------

local function Rune_Ring_Color(frame, color)
	frame.LR.Ring: SetVertexColor(F.Color(color))
	frame.RR.Ring: SetVertexColor(F.Color(color))
end

local function Rune_Ring_Update(frame, value)
	if frame.LR then
		if not value then value = 1 end
		value = min(max(value, 0),1)
		if value < 0.5 then
			frame.LR.Ring:SetRotation(math.rad(frame.LR.Base+0))
			frame.RR.Ring:SetRotation(math.rad(frame.RR.Base-180*value*2))
		else
			frame.LR.Ring:SetRotation(math.rad(frame.LR.Base-180*(value*2-1)))
			frame.RR.Ring:SetRotation(math.rad(frame.RR.Base+180))
		end
	end
end

local function Rune_Ring_Artwork(frame, size)
	frame.C = CreateFrame("Frame", nil, frame)
	frame.C: SetSize(size, size)
	frame: SetScrollChild(frame.C)
	
	frame.Ring = frame.C:CreateTexture(nil, "BACKGROUND", nil, -2)
	frame.Ring: SetTexture(F.Path("Ring16_2"))
	frame.Ring: SetSize(size, size)
    frame.Ring: SetPoint("CENTER")
	frame.Ring: SetAlpha(1)
	frame.Ring: SetBlendMode("BLEND")
	frame.Ring: SetRotation(math.rad(frame.Base+180))
end

local function Rune_Ring_Create(f, size1, size2)
	f.RingTimer = 0
	f.RingDuration = 0
	
	local level = f:GetFrameLevel() - 1
	
	f.LR = CreateFrame("ScrollFrame", nil, f)
	f.LR: SetFrameLevel(level)
	f.LR: SetSize((size2)/2, size2)
	f.LR: SetPoint("RIGHT", f, "CENTER", 0,0)
	f.LR.Base = -180
	Rune_Ring_Artwork(f.LR, size2)
	
	f.RR = CreateFrame("ScrollFrame", nil, f)
	f.RR: SetFrameLevel(level)
	f.RR: SetSize((size2)/2, size2)
	f.RR: SetPoint("LEFT", f, "CENTER", 0,0)
	f.RR: SetHorizontalScroll((size2)/2)
	f.RR.Base = 0
	Rune_Ring_Artwork(f.RR, size2)
	
	local Bg1 = f:CreateTexture(nil, "BACKGROUND", nil, -1)
	Bg1: SetTexture(F.Path("Ring32_Bg"))
	Bg1: SetSize(size1, size1)
	Bg1: SetPoint("CENTER", f ,"CENTER", 0,0)
	Bg1: SetVertexColor(F.Color(C.Color.Black))
	
	local Bg2 = f.LR:CreateTexture(nil, "BACKGROUND", nil, -3)
	Bg2: SetTexture(F.Path("Ring32_Bg"))
	Bg2: SetSize(size1+12, size1+12)
	Bg2: SetPoint("CENTER", f ,"CENTER", 0,0)
	Bg2: SetVertexColor(F.Color(C.Color.Black))
	Bg2: SetBlendMode("BLEND")
end

local function Rune_OnEvent(frame)
	frame: RegisterEvent("PLAYER_ENTERING_WORLD")
	frame: RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
	frame: RegisterEvent("RUNE_POWER_UPDATE")
	--frame: RegisterEvent("RUNE_TYPE_UPDATE")
	frame: RegisterEvent("PLAYER_REGEN_DISABLED")
	frame: RegisterEvent("PLAYER_REGEN_ENABLED")
	frame: SetScript("OnEvent", function(self, event, ...)
		--if event == "PLAYER_ENTERING_WORLD" then
		--	self.Info.Class = select(2, UnitClass("player"))
		--	if self.Info.Class == 'DEATHKNIGHT' then
		--		self: Show()
		--	end
		--end
		if (event == "PLAYER_ENTERING_WORLD") or (event == "PLAYER_SPECIALIZATION_CHANGED") then
			self.Info.SpecID = GetSpecialization()
			for i = 1,3 do
				self.Point[i].Bar: SetVertexColor(F.Color(C.Color.Rune[self.Info.SpecID]))
			end
		end
		--if self.Info.Class == 'DEATHKNIGHT' then
			self.Info.E = 0
			for i = 1,6 do
				self.Rune[i] = {start = 0, timer = 0, duration = 0, ready = 0}
				local start, duration, runeReady = GetRuneCooldown(i)
				if runeReady then
					self.Info.E = self.Info.E + 1
				end
				self.Rune[i].start = start or 0
				self.Rune[i].duration = duration
				self.Rune[i].ready = runeReady
				if self.Rune[i].ready then
					self.Rune[i].timer = self.Rune[i].duration
				else
					self.Rune[i].timer = GetTime() - self.Rune[i].start
				end
			end
			table.sort(self.Rune, function(v1,v2) return v1.timer > v2.timer end)
			for i = 1,3 do
				if self.Rune[i].ready and self.Rune[i+3].ready then
					Rune_Ring_Color(self.Point[i], C.Color.Rune[self.Info.SpecID])
				else
					Rune_Ring_Color(self.Point[i], C.Color.W4)
				end
			end
			if UnitAffectingCombat("player") then
				self: SetAlpha(1)
			elseif self.Info.E ~= 6 then
				self: SetAlpha(0.4)
			else
				self: SetAlpha(0)
			end
		--end
	end)
end

local function Rune_OnUpdate(frame)
	local Elapsed_Help = 0
	frame: SetScript("OnUpdate", function(self, elapsed)
		Elapsed_Help = Elapsed_Help + elapsed
		if (F.Last25H == 0) then
			for i = 1,3 do
				if self.Rune[i].ready then
					self.Point[i].Bar:Show()
					Rune_Ring_Update(self.Point[i], self.Rune[i+3].timer/self.Rune[i+3].duration)
				else
					self.Point[i].Bar:Hide()
					Rune_Ring_Update(self.Point[i], self.Rune[i].timer/self.Rune[i].duration)
				end
			end
			for i = 1,6 do
				if not self.Rune[i].ready then
					self.Rune[i].timer = min(self.Rune[i].timer + Elapsed_Help, self.Rune[i].duration)
				end
			end
			Elapsed_Help = 0
		end
	end)
end

local function Rune_Frame(frame)
	local class = select(2, UnitClass("player"))
	if class ~= 'DEATHKNIGHT' then return end

	local Runes = CreateFrame("Frame", nil, frame)
	Runes: SetSize(32,32)
	Runes: SetPoint("CENTER", frame, "CENTER", 0,-120)

	Runes.Info = {}
	Runes.Info.Max = 0
	Runes.Info.SpecID = 3
	Runes.Point = {}
	Runes.Rune = {}
	for i = 1,3 do
		local Point = CreateFrame("Frame", nil, Runes)
		Point: SetSize(16,16)
		Point: SetPoint("CENTER", Runes, "CENTER", 28*(i-2), 0)

		local Bar = Point: CreateTexture(nil, "ARTWORK")
		Bar: SetTexture(F.Path("Ring16_Bg"))
		Bar: SetSize(32,32)
		Bar: SetPoint("CENTER", Point, "CENTER", 0,0)
		Bar: SetAlpha(1)

		local BarBg = Point: CreateTexture(nil, "BACKGROUND")
		BarBg: SetTexture(F.Path("Ring16_Bg"))
		BarBg: SetVertexColor(F.Color(C.Color.White))
		BarBg: SetSize(32,32)
		BarBg: SetPoint("CENTER", Point, "CENTER", 0,0)
		BarBg: SetAlpha(0.25)

		Rune_Ring_Create(Point, 16, 32)

		Runes.Point[i] = Point
		Runes.Point[i].Bar = Bar
	end

	Rune_OnEvent(Runes)
	Rune_OnUpdate(Runes)
end

----------------------------------------------------------------
--> GCD
----------------------------------------------------------------

local function GCD_Artwork(frame)
	local Bg1 = frame: CreateTexture(nil, "BACKGROUND")
	Bg1: SetTexture(MEKA.Path("RingBar\\Bar5_Bar"))
	Bg1: SetVertexColor(F.Color(C.Color.Main0))
	Bg1: SetAlpha(0.65)
	Bg1: SetSize(55,32)
	Bg1: SetTexCoord(0/4096,110/4096, 0,1)
	Bg1: SetPoint("BOTTOMLEFT", frame, "BOTTOM", 0,0)

	local BgGlow1 = frame: CreateTexture(nil, "BORDER")
	BgGlow1: SetTexture(MEKA.Path("RingBar\\Bar5_Bar"))
	BgGlow1: SetVertexColor(F.Color(C.Color.Main1))
	BgGlow1: SetAlpha(0.15)
	BgGlow1: SetSize(55,32)
	BgGlow1: SetTexCoord(0/4096,110/4096, 0,1)
	BgGlow1: SetPoint("BOTTOMLEFT", frame, "BOTTOM", 0,0)

	local Bg2 = frame: CreateTexture(nil, "BACKGROUND")
	Bg2: SetTexture(MEKA.Path("RingBar\\Bar5_Bar"))
	Bg2: SetVertexColor(F.Color(C.Color.Main0))
	Bg2: SetAlpha(0.65)
	Bg2: SetSize(55,32)
	Bg2: SetTexCoord(110/4096,0/4096, 0,1)
	Bg2: SetPoint("BOTTOMRIGHT", frame, "BOTTOM", 0,0)

	local BgGlow2 = frame: CreateTexture(nil, "BORDER")
	BgGlow2: SetTexture(MEKA.Path("RingBar\\Bar5_Bar"))
	BgGlow2: SetVertexColor(F.Color(C.Color.Main1))
	BgGlow2: SetAlpha(0.15)
	BgGlow2: SetSize(55,32)
	BgGlow2: SetTexCoord(110/4096,0/4096, 0,1)
	BgGlow2: SetPoint("BOTTOMRIGHT", frame, "BOTTOM", 0,0)

	local Gloss = frame: CreateTexture(nil, "BACKGROUND")
	Gloss: SetTexture(MEKA.Path("RingBar\\Bar5_Bar"))
	Gloss: SetVertexColor(F.Color(C.Color.Main1))
	Gloss: SetAlpha(0.25)
	Gloss: SetSize(114,32)
	Gloss: SetTexCoord(3868/4096,4096/4096, 0,1)
	Gloss: SetPoint("BOTTOM", frame, "BOTTOM", 0,0)

	local BarR = frame: CreateTexture(nil, "ARTWORK")
	BarR: SetTexture(MEKA.Path("RingBar\\Bar5_Bar"))
	BarR: SetVertexColor(F.Color(C.Color.Main1))
	BarR: SetAlpha(1)
	BarR: SetSize(55,32)
	BarR: SetTexCoord(0/4096,110/4096, 0,1)
	BarR: SetPoint("BOTTOMLEFT", frame, "BOTTOM", 0,0)

	local BarL = frame: CreateTexture(nil, "ARTWORK")
	BarL: SetTexture(MEKA.Path("RingBar\\Bar5_Bar"))
	BarL: SetVertexColor(F.Color(C.Color.Main1))
	BarL: SetAlpha(1)
	BarL: SetSize(55,32)
	BarL: SetTexCoord(110/4096,0/2048, 0,1)
	BarL: SetPoint("BOTTOMRIGHT", frame, "BOTTOM", 0,0)

	frame.BarL = BarL
	frame.BarR = BarR
	frame.Gloss = Gloss
end



local function GCD_Update(frame, d, remain)
	if not d then d = 0 end
	if d > 1 then d = 1 end
	if d < 0 then d = 0 end

	--f.Bar: SetSize(154, 34*d+F.Debug)
	--f.Bar: SetTexCoord(51/256,205/256, (15+34*abs(1-d))/64,49/64)
	--f.Text: SetText(format("%.1f", remain))

	d = floor(d*22+0.5)
	frame.BarR: SetTexCoord((110*abs(22-d))/4096,(110*abs(23-d))/4096, 0,1)
	frame.BarL: SetTexCoord((110*abs(23-d))/4096,(110*abs(22-d))/4096, 0,1)

	if remain <= frame.SQW then
		frame.BarL: SetVertexColor(F.Color(C.Color.Main2))
		frame.BarR: SetVertexColor(F.Color(C.Color.Main2))
		frame.Gloss: SetVertexColor(F.Color(C.Color.Main2))
	else
		frame.BarL: SetVertexColor(F.Color(C.Color.Main1))
		frame.BarR: SetVertexColor(F.Color(C.Color.Main1))
		frame.Gloss: SetVertexColor(F.Color(C.Color.Main1))
	end
end

local function Get_GCD()
	local start, duration, enabled = GetSpellCooldown(61304)
	local remain = max((GetTime() - start), 0)
	return remain, duration
end

local function GCD_Frame(f)
	f.GCD = CreateFrame("Frame", nil, f)
	f.GCD: SetSize(112,82)
	f.GCD: SetPoint("TOP", f, "CENTER", 0,0)
	f.GCD.SQW = 0.4
	f.GCD: Hide()
	GCD_Artwork(f.GCD)

	f.GCD: RegisterEvent("SPELL_UPDATE_COOLDOWN")
	f.GCD: RegisterEvent("PLAYER_ENTERING_WORLD")
	f.GCD: RegisterEvent("CVAR_UPDATE")
	--f.GCD: RegisterEvent("PLAYER_REGEN_DISABLED")
	--f.GCD: RegisterEvent("PLAYER_REGEN_ENABLED")
	f.GCD: SetScript("OnEvent", function(self,event)
		if event == "PLAYER_ENTERING_WORLD" or event == "SPELL_UPDATE_COOLDOWN" then
			f.GCD.Remain, f.GCD.CD = Get_GCD()
			if (f.GCD.Remain > 0 and f.GCD.CD > f.GCD.Remain) then
				f.GCD: Show()
				f.GCD: SetScript("OnUpdate", function(self, elapsed)
					if f.GCD.Remain > 0 and f.GCD.CD > f.GCD.Remain then
						GCD_Update(self, f.GCD.Remain/f.GCD.CD, f.GCD.CD-f.GCD.Remain)
						f.GCD.Remain = f.GCD.Remain + elapsed
					else
						GCD_Update(self, 0, 0)
						f.GCD: Hide()
						f.GCD: SetScript("OnUpdate", nil)
					end
				end)
			end
		end
		if event == "PLAYER_ENTERING_WORLD" or event == "CVAR_UPDATE" then
			self.SQW = GetCVar("SpellQueueWindow")/1000
		end
	end)
end

--- ------------------------------------------------------------
--> Mirror
--- ------------------------------------------------------------

local function Mirror_Artwork(f, p)
	local Bg = f: CreateTexture(nil, "BACKGROUND")
	Bg: SetTexture(F.Path("TieBar4\\Bar1"))
	Bg: SetVertexColor(F.Color(C.Color.W1))
	Bg: SetAlpha(0.6)
	Bg: SetSize(8, 42)
	Bg: SetTexCoord(4/16,12/16, 11/64,53/64)
	Bg: SetPoint("CENTER", f, "CENTER", 0,0)

	local Bg_Glow = f: CreateTexture(nil, "BORDER")
	Bg_Glow: SetTexture(F.Path("TieBar4\\Bar1"))
	Bg_Glow: SetVertexColor(F.Color(C.Color.W3))
	Bg_Glow: SetAlpha(0.1)
	Bg_Glow: SetSize(8, 42)
	Bg_Glow: SetTexCoord(4/16,12/16, 11/64,53/64)
	Bg_Glow: SetPoint("CENTER", f, "CENTER", 0,0)

	local Bar = f: CreateTexture(nil, "ARTWORK")
	Bar: SetTexture(F.Path("TieBar4\\Bar1"))
	Bar: SetVertexColor(F.Color(C.Color.B3))
	Bar: SetAlpha(0.8)
	Bar: SetSize(8, 42)
	Bar: SetTexCoord(4/16,12/16, 11/64,53/64)
	Bar: SetPoint("BOTTOM", Bg, "BOTTOM", 0,0)

	local nonius = f: CreateTexture(nil, "OVERLAY")
	nonius: SetTexture(F.Path("TieBar4\\Border1"))
	nonius: SetVertexColor(F.Color(C.Color.W3))
	nonius: SetAlpha(0.8)
	nonius: SetSize(32,32)
	nonius: SetPoint("CENTER", p, "CENTER", 118*cos(rad(10)), 118*sin(rad(10)))
	F.RotateTexture(nonius, 10)

	local Bd = CreateFrame("Frame", nil, f)
	for i = 1,3 do
		Bd[i] = Bd: CreateTexture(nil, "BACKGROUND")
		Bd[i]: SetTexture(F.Path("TieBar4\\Border2"))
		Bd[i]: SetVertexColor(F.Color(C.Color.W3))
		Bd[i]: SetAlpha(0.8)
		Bd[i]: SetSize(8,8)
		Bd[i]: SetPoint("CENTER", p, "CENTER", 121*cos(rad(-10+10*(i-1))), 121*sin(rad(-10+10*(i-1))))
		F.RotateTexture(Bd[i], -10+10*(i-1))
	end

	f.Text = F.create_Font(f, C.Font["NumSmall"], 12, nil, 0.8, "LEFT", "CENTER")
	f.Text: SetPoint("LEFT", Bg, "RIGHT", 20,0)

	f.Bar = Bar
	f.Nonius = nonius
end

local function Mirror_Refresh(f)
	f.Mode = "UNKNOWN"
	f.Duration = 0
	f.Text: SetText(" ")
end

local function TieBar4_Update(f, d, p)
	if not d then d = 0 end
	if d > 1 then d = 1 end
	if d < 0 then d = 0 end
	local r = d * 20

	f.Bar: SetSize(8, 42*d+F.Debug)
	f.Bar: SetTexCoord(4/16,12/16, (11+42*abs(1-d))/64,53/64)
	f.Nonius: SetPoint("CENTER", p, "CENTER", 118*cos(rad(-10+r)), 118*sin(rad(-10+r)))
	F.RotateTexture(f.Nonius, -10+r)
end

local function Mirror_Update(f, p)
	if f.Mode ~= "UNKNOWN" then
		local value = GetMirrorTimerProgress(f.Mode)
		value = value > f.Duration and f.Duration or value
		TieBar4_Update(f, value/f.Duration, p)
		f.Text: SetText(F.FormatTime(value/1000))
	else
		for i = 1, MIRRORTIMER_NUMTIMERS do
			local timer, initial, maxvalue, scale, paused, label = GetMirrorTimerInfo(i)
			if timer ~= "UNKNOWN" then
				f.Mode = timer
				f.Duration = maxvalue
			end
		end
	end
end

local function Mirror_OnUpdate(f, p)
	f: SetScript("OnUpdate", function(self, elapsed)
		Mirror_Update(self, p)
	end)
end

local function Mirror_Event(f, event)
	if event == "PLAYER_ENTERING_WORLD" or event == "MIRROR_TIMER_START" or event == "MIRROR_TIMER_PAUSE" then
		local currentTime = GetTime()
		Mirror_Refresh(f)
		for i = 1, MIRRORTIMER_NUMTIMERS do
			local timer, initial, maxvalue, scale, paused, label = GetMirrorTimerInfo(i)
			if timer ~= "UNKNOWN" then
				f.Mode = timer
				f.Duration = maxvalue
			end
		end
		if event == "PLAYER_ENTERING_WORLD" then
			if f.Mode == "UNKNOWN" then
				f: Hide()
			else
				f: Show()
			end
		end
	end
	
	if event == "MIRROR_TIMER_START" then
		f: Show()
	elseif event == "MIRROR_TIMER_STOP" then
		f: Hide()
	end
end

local function Mirror_OnEvent(f)
	f: RegisterEvent("PLAYER_ENTERING_WORLD")
	f: RegisterEvent("MIRROR_TIMER_PAUSE")
	f: RegisterEvent("MIRROR_TIMER_START")
	f: RegisterEvent("MIRROR_TIMER_STOP")
	f: RegisterEvent("READY_CHECK")
	f: RegisterEvent("READY_CHECK_FINISHED")
	f: RegisterEvent("LFG_PROPOSAL_FAILED")
	f: RegisterEvent("LFG_PROPOSAL_SUCCEEDED")
	f: SetScript("OnEvent", function(self, event)
		Mirror_Event(self, event)
	end)
end

local function Mirror_Frame(f)
	local Mirror = CreateFrame("Frame", nil, f)
	Mirror: SetSize(8, 42)
	Mirror: SetPoint("CENTER", f, "CENTER", 113,0)

	Mirror_Artwork(Mirror, f)
	Mirror_Refresh(Mirror)
	Mirror_OnEvent(Mirror, f)
	Mirror_OnUpdate(Mirror, f)

	f.Mirror = Mirror
end

--- ------------------------------------------------------------
--> Load
--- ------------------------------------------------------------

local MEKA_FCS_Center = CreateFrame("Frame", "MEKA_FCS.Center", E)
MEKA_FCS_Center: SetSize(202,54)
MEKA_FCS_Center: SetPoint("CENTER", UIParent, "CENTER", 0,0)
local function Load()
	GCD_Frame(MEKA_FCS_Center)
	Mirror_Frame(MEKA_FCS_Center)
	Points_Frame(MEKA_FCS_Center)
	Rune_Frame(MEKA_FCS_Center)
end
MEKA_FCS_Center.Load = Load
tinsert(E.Module, MEKA_FCS_Center)